""""This function calibrates the transcriptional time traces.

Starting from the escel file 'DividedByBackground_SpatialSelected', 
the algorithm generates another excel in which all the values of the 
first are divided by the calibration value.
"""


import xlwt
import datetime
from xlrd import open_workbook

from PyQt5 import QtGui, QtWidgets



class CalibrationSpatial:
    def __init__(self, foldername, calib_value):

        exp_name  =  foldername[len(foldername) - foldername[:-1][::-1].find('/') - 1:]

        wb_starting  =  open_workbook(foldername + '/DividedByBackground_SpatialSelected.xls')
        s_starting   =  wb_starting.sheets()[0]

        book    =  xlwt.Workbook(encoding='utf-8')
        sheet1  =  book.add_sheet("Sheet 1")

        sheet1.write(1, 0, "date")
        sheet1.write(1, 1, datetime.datetime.now().strftime("%d-%b-%Y"))

        sheet1.write(3, 0, "Calib Value")
        sheet1.write(3, 1, calib_value)

        pbar      =  ProgressBar(total1=s_starting.ncols)
        pbar_idx  =  0
        pbar.show()

        for k in range(s_starting.ncols):
            sheet1.write(0, k, s_starting.col(k)[0].value)

        for k_col in range(4, s_starting.ncols):
            pbar_idx  += 1
            pbar.update_progressbar(pbar_idx)
            for k_row in range(2, s_starting.nrows):
                sheet1.write(k_row, k_col, s_starting.col(k_col)[k_row].value / calib_value)

        pbar.close()
        book.save(foldername + '/' + exp_name + '_' + 'CalibratedTraces.xls')



class ProgressBar(QtGui.QWidget):
    def __init__(self, parent=None, total1=20):
        super(ProgressBar, self).__init__(parent)
        self.name_line1  =  QtGui.QLineEdit()

        self.progressbar  =  QtWidgets.QProgressBar()
        self.progressbar.setMinimum(1)
        self.progressbar.setMaximum(total1)

        main_layout  =  QtGui.QGridLayout()
        main_layout.addWidget(self.progressbar, 0, 0)

        self.setLayout(main_layout)
        self.setWindowTitle("Progress")
        self.setGeometry(500, 300, 300, 50)

    def update_progressbar(self, val1):
        self.progressbar.setValue(val1)
        QtWidgets.qApp.processEvents()

