"""This function calculates the circularity, defined as the ratio between
4*np.pi*A and the p**2 (A is the surface and p is the perimeter), of all
the connected objects present in the image-matrix labels. This function
returns a 2D matrix with the value of the circularity (ies) and the label
of the connected object.
"""


import numpy as np
from skimage import measure


class CircularityEstimate:
    """The only class, does all job"""
    def __init__(self, labels):
        self.labels  =  labels

        rgp_left   =  measure.regionprops(self.labels)
        circ       =  np.zeros((2, len(rgp_left)))

        for k in range(len(rgp_left)):
            circ[:, k]  =  4 * np.pi * rgp_left[k]['Area'] / rgp_left[k]['Perimeter'] ** 2, rgp_left[k]['Label']   # calculate circularity as 4 pi Area / perim**2, and tag

        self.circ  =  circ
