"""This function removes fake spots detections.

It takes as input tracked spots.
"""


import numpy as np


class FakeSpotsRemover:
    """The only class, does all the job"""
    def __init__(self, spts_tracked):
        self.spts_tracked  =  spts_tracked    # input[0]

        idxs        =  np.unique(self.spts_tracked)[1:]                             # list of spots tags
        delete_msk  =  np.zeros(self.spts_tracked.shape)                            # initialize the matrix of the spots to remove

        for k in idxs:
            profile  =  np.sign((self.spts_tracked == k).sum(2).sum(1))             # binary presence series of the each spot
            prof_d2  =  np.diff(profile, 2)                                         # derivative
            zero_jj  =  np.where(prof_d2 == -2)[0] + 1                              # search when the second derivative is equal to -2 for isolated spots [0,0,0,0,0,1,0,0,0] -> [0,0,0,0,-2,0,0,0]

            for l in zero_jj:
                delete_msk[l, :, :]  +=  (self.spts_tracked[l, :, :] == k)          # matrix with all the spots to remove

            if profile[0] == 1 and profile[1] == 0:                                 # particular condition for the beginning and the ends
                delete_msk[0, :, :]  +=  (self.spts_tracked[0, :, :] == k)
            if profile[-1] == 1 and profile[-2] == 0:
                delete_msk[-1, :, :]  +=  (self.spts_tracked[-1, :, :] == k)


        spts_tracked_filtered  =  self.spts_tracked * (1 - delete_msk)

        self.spts_tracked_filtered  =  spts_tracked_filtered
        # self.delete_msk             =  delete_msk



