"""This function provides only a pg.image frame with frame number.


"""


import pyqtgraph as pg


class PopUpTool:
    """Popup for images without colormap"""
    def __init__(self, img, img_title):

        w  =  pg.image(img, title=img_title)                            # image frame

        lx  =  []
        for t in range(img.shape[0]):
            lx.append(pg.TextItem(str(t), color='r', anchor=(0, 1)))    # list of all the numbers
        w.addItem(lx[0])                                                # add the current number
        self.current  =  0                                              # initialize with 0

        def upadateframe():
            """Number updater"""
            w.removeItem(lx[self.current])                              # when activate removes the current number item
            w.addItem(lx[w.currentIndex])                               # add the number itel correspondent with the frame idx
            self.current  =  w.currentIndex                             # update current

        w.timeLine.sigPositionChanged.connect(upadateframe)



class PopUpToolWithMap:
    """Popup for images with colormap"""
    def __init__(self, img, img_title, cmap):

        w  =  pg.image(img, title=img_title)
        w.setColorMap(cmap)

        lx  =  []
        for t in range(img.shape[0]):
            lx.append(pg.TextItem(str(t), color='r', anchor=(0, 1)))
        w.addItem(lx[0])
        self.current  =  0

        def upadateframe():
            w.removeItem(lx[self.current])
            w.addItem(lx[w.currentIndex])
            self.current  =  w.currentIndex

        w.timeiLine.sigPositionChanged.connect(upadateframe)
