"""This function generate an excel file with the intensity divided by background in a pattern.

It loads and combines all the information of the excel file of the spatial analysis and
spots intensity divided by background and generate an excel with only the info of the
selected spots.
"""


import datetime
import xlwt
from xlrd import open_workbook
from PyQt5 import QtWidgets



class SpatialDividedByBkg:
    """Main class, does the all job"""
    def __init__(self, foldername, time_zero, time_step_value):

        wb_bybkg     =  open_workbook(foldername + '/SpotsIntensityDividedByBackground.xls')
        s_wb_bybkg1  =  wb_bybkg.sheets()[0]
        s_wb_bybkg2  =  wb_bybkg.sheets()[1]
        s_wb_bybkg3  =  wb_bybkg.sheets()[2]
        s_wb_bybkg4  =  wb_bybkg.sheets()[3]
        nrows_bybkg  =  s_wb_bybkg1.nrows

        wb_spat    =  open_workbook(foldername + '/ComprehensiveBurstingData.xls')
        s_wb_spat  =  wb_spat.sheets()[0]

        row_start  =  0
        while str(s_wb_spat.col(0)[row_start].value) != "Nuclei ID":
            row_start  +=  1

        spt_ids  =  []
        j        =  row_start + 1
        while str(s_wb_spat.col(0)[j].value)[:4] == "Nuc_":
            spt_ids.append(str(s_wb_spat.col(0)[j].value)[4:])
            j  +=  1

        col_coords  =  []
        for k in spt_ids:
            for l in range(s_wb_bybkg1.ncols):
                if str(s_wb_bybkg1.col(l)[0].value)[6:] == k:
                    col_coords.append(l)

        pbar  =  ProgressBar(total1=len(col_coords))
        pbar.show()


        book    =  xlwt.Workbook(encoding='utf-8')
        sheet1  =  book.add_sheet("Spots by Background")
        sheet2  =  book.add_sheet("Average Background")
        sheet3  =  book.add_sheet("Background Std")
        sheet4  =  book.add_sheet("Average Spots by Background")

        sheet1.write(0, 0, str(s_wb_bybkg1.col(0)[0].value))
        sheet1.write(0, 1, str(s_wb_bybkg1.col(1)[0].value))
        sheet1.write(1, 0, "date")
        sheet1.write(1, 1, datetime.datetime.now().strftime("%d-%b-%Y"))
        sheet1.write(0, 2, "Frame")
        sheet1.write(0, 3, "Time")

        for t in range(1, nrows_bybkg):
            sheet1.write(t + 1, 2, t - 1)
            sheet2.write(t + 1, 2, t - 1)
            sheet3.write(t + 1, 2, t - 1)
            sheet4.write(t + 1, 2, t - 1)

            sheet1.write(t + 1, 3, (t - 1 + time_zero) * time_step_value)
            sheet2.write(t + 1, 3, (t - 1 + time_zero) * time_step_value)
            sheet3.write(t + 1, 3, (t - 1 + time_zero) * time_step_value)
            sheet4.write(t + 1, 3, (t - 1 + time_zero) * time_step_value)

        idx_wrt   =  4
        pbar_idx  =  1
        for k in col_coords:
            pbar.update_progressbar(pbar_idx)
            sheet1.write(0, idx_wrt, "SptId_" + str(spt_ids[idx_wrt - 4]))
            sheet2.write(0, idx_wrt, "SptId_" + str(spt_ids[idx_wrt - 4]))
            sheet3.write(0, idx_wrt, "SptId_" + str(spt_ids[idx_wrt - 4]))
            sheet4.write(0, idx_wrt, "SptId_" + str(spt_ids[idx_wrt - 4]))

            for o in range(1, nrows_bybkg):
                sheet1.write(o + 1, idx_wrt, s_wb_bybkg1.col(k)[o].value)
                sheet2.write(o + 1, idx_wrt, s_wb_bybkg2.col(k)[o].value)
                sheet3.write(o + 1, idx_wrt, s_wb_bybkg3.col(k)[o].value)
                sheet4.write(o + 1, idx_wrt, s_wb_bybkg4.col(k)[o].value)

            idx_wrt   +=  1
            pbar_idx  +=  1

        pbar.close()    

        book.save(foldername + '/DividedByBackground_SpatialSelected.xls')




class ProgressBar(QtWidgets.QWidget):
    """This is a simple progress bar"""
    def __init__(self, parent=None, total1=20):
        super(ProgressBar, self).__init__(parent)
        self.name_line1  =  QtWidgets.QLineEdit()

        self.progressbar1  =  QtWidgets.QProgressBar()
        self.progressbar1.setMinimum(1)
        self.progressbar1.setMaximum(total1)

        main_layout  =  QtWidgets.QGridLayout()
        main_layout.addWidget(self.progressbar1, 0, 0)

        self.setLayout(main_layout)
        self.setWindowTitle("Progress")
        self.setGeometry(500, 300, 300, 50)

    def update_progressbar(self, val1):
        """Method to update the progress bar"""
        self.progressbar1.setValue(val1)
        QtWidgets.qApp.processEvents()
